Package org.gradle.caching.configuration

## Interface BuildCacheConfiguration

-     public interface BuildCacheConfiguration

  Configuration for the build cache for an entire Gradle build.
  Since:
    3.5

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DirectoryBuildCache` | `getLocal()` | Returns the local directory cache configuration.
    `BuildCache` | `getRemote()` | Returns the remote cache configuration.
    `<T extends DirectoryBuildCache> T` | `local​(java.lang.Class<T> type)` | Deprecated. Use `getLocal()` instead.
    `<T extends DirectoryBuildCache> T` | `local​(java.lang.Class<T> type, Action<? super T> configuration)` | Deprecated. Use `local(Action)` instead.
    `void` | `local​(Action<? super DirectoryBuildCache> configuration)` | Executes the given action against the local configuration.
    `<T extends BuildCache> void` | `registerBuildCacheService​(java.lang.Class<T> configurationType, java.lang.Class<? extends BuildCacheServiceFactory<? super T>> buildCacheServiceFactoryType)` | Registers a custom build cache type.
    `<T extends BuildCache> T` | `remote​(java.lang.Class<T> type)` | Configures a remote cache with the given type.
    `<T extends BuildCache> T` | `remote​(java.lang.Class<T> type, Action<? super T> configuration)` | Configures a remote cache with the given type.
    `void` | `remote​(Action<? super BuildCache> configuration)` | Executes the given action against the currently configured remote cache.

- - ### Method Detail

    - #### registerBuildCacheService

          <T extends BuildCache> void registerBuildCacheService​(java.lang.Class<T> configurationType,
                                                                java.lang.Class<? extends BuildCacheServiceFactory<? super T>> buildCacheServiceFactoryType)

      Registers a custom build cache type.
      Parameters:
        `configurationType` - Configuration type used to provide parameters to a `BuildCacheService`
        `buildCacheServiceFactoryType` - Implementation type of `BuildCacheServiceFactory` that is used to create a `BuildCacheService`

    - #### getLocal

          DirectoryBuildCache getLocal()

      Returns the local directory cache configuration.

    - #### local

          @Deprecated
          <T extends DirectoryBuildCache> T local​(java.lang.Class<T> type)

      Deprecated.
      Use `getLocal()` instead.
      Configures the local cache with the given type.

      Note: using any type except `DirectoryBuildCache` is invalid.

      Parameters:
        `type` - the type of local cache to configure.

    - #### local

          @Deprecated
          <T extends DirectoryBuildCache> T local​(java.lang.Class<T> type,
                                                  Action<? super T> configuration)

      Deprecated.
      Use `local(Action)` instead.
      Configures the local cache with the given type.

      Note: using any type except `DirectoryBuildCache` is invalid.

      Parameters:
        `type` - the type of local cache to configure.
        `configuration` - the configuration to execute against the remote cache.

    - #### local

          void local​(Action<? super DirectoryBuildCache> configuration)

      Executes the given action against the local configuration.
      Parameters:
        `configuration` - the action to execute against the local cache configuration.

    - #### getRemote

          @Nullable
          BuildCache getRemote()

      Returns the remote cache configuration.

    - #### remote

          <T extends BuildCache> T remote​(java.lang.Class<T> type)

      Configures a remote cache with the given type.

      If a remote build cache has already been configured with a different type, this method replaces it.

      Storing ("push") in the remote build cache is disabled by default.

      Parameters:
        `type` - the type of remote cache to configure.

    - #### remote

          <T extends BuildCache> T remote​(java.lang.Class<T> type,
                                          Action<? super T> configuration)

      Configures a remote cache with the given type.

      If a remote build cache has already been configured with a different type, this method replaces it.

      If a remote build cache has already been configured with the same, this method configures it.

      Storing ("push") in the remote build cache is disabled by default.

      Parameters:
        `type` - the type of remote cache to configure.
        `configuration` - the configuration to execute against the remote cache.

    - #### remote

          void remote​(Action<? super BuildCache> configuration)

      Executes the given action against the currently configured remote cache.
      Parameters:
        `configuration` - the action to execute against the currently configured remote cache.
      Throws:
        `java.lang.IllegalStateException` - If no remote cache has been assigned yet